#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include"util.h"
#include"movement_tagger.h"

int movement_tagger(config *c, int postag, float score, int stream)
{
  word *b0 = NULL;
  int k = 5;
  
  if(queue_is_empty(c->bf)) return 0;

  b0 = queue_remove(c->bf);
  word_set_pos(b0, postag); 
  stack_push(c->st, b0);

  /* in stream mode, read a new word, add it to the buffer and keen only (k = 5) elts in the stack */
  if(stream){
    stack_trim_to_size(c->st, k); 
    config_add_next_word_to_buffer(c);
  }

  return 1;
}
