#ifndef __STACK__
#define __STACK__

#include<stdio.h>
#include"word.h"

#define stack_height(s) (s)->top 
#define stack_nbelem(s) (s)->top 
#define stack_elt_n(s, n) (s)->array[(s)->top - (n) - 1]

typedef struct {
  int size;
  word **array;
  int top;
} stack;

stack *stack_new(void);
stack *stack_copy(stack *s);
word *stack_pop(stack *s);
void stack_push(stack *s, word *w);
word *stack_top(stack *s);
void stack_print(FILE *buffer, stack *s);
void stack_free(stack *s);
int stack_is_empty(stack *s);
/* int stack_height(stack *s); */
void stack_trim_to_size(stack *s, int k);
#endif
