#ifndef __WORD__
#define __WORD__

#include "mcd.h"

#define word_get_index(w) (w)->feat_array[FEAT_TYPE_INDEX]
#define word_get_form(w)  (w)->feat_array[FEAT_TYPE_FORM]
#define word_get_lemma(w) (w)->feat_array[FEAT_TYPE_LEMMA]
#define word_get_cpos(w)  (w)->feat_array[FEAT_TYPE_CPOS]
#define word_get_pos(w)   (w)->feat_array[FEAT_TYPE_POS]
#define word_get_feats(w) (w)->feat_array[FEAT_TYPE_FEATS]
#define word_get_gov(w)   (w)->feat_array[FEAT_TYPE_GOV]
#define word_get_label(w) (w)->feat_array[FEAT_TYPE_LABEL]
#define word_get_stag(w)  (w)->feat_array[FEAT_TYPE_STAG]
#define word_get_A(w)     (w)->feat_array[FEAT_TYPE_A]
#define word_get_B(w)     (w)->feat_array[FEAT_TYPE_B]
#define word_get_C(w)     (w)->feat_array[FEAT_TYPE_C]
#define word_get_D(w)     (w)->feat_array[FEAT_TYPE_D]
#define word_get_E(w)     (w)->feat_array[FEAT_TYPE_E]
#define word_get_F(w)     (w)->feat_array[FEAT_TYPE_F]
#define word_get_G(w)     (w)->feat_array[FEAT_TYPE_G]
#define word_get_H(w)     (w)->feat_array[FEAT_TYPE_H]
#define word_get_I(w)     (w)->feat_array[FEAT_TYPE_I]
#define word_get_J(w)     (w)->feat_array[FEAT_TYPE_J]
#define word_get_K(w)     (w)->feat_array[FEAT_TYPE_K]
#define word_get_L(w)     (w)->feat_array[FEAT_TYPE_L]
#define word_get_M(w)     (w)->feat_array[FEAT_TYPE_M]
#define word_get_N(w)     (w)->feat_array[FEAT_TYPE_N]
#define word_get_O(w)     (w)->feat_array[FEAT_TYPE_O]
#define word_get_P(w)     (w)->feat_array[FEAT_TYPE_P]
#define word_get_Q(w)     (w)->feat_array[FEAT_TYPE_Q]
#define word_get_R(w)     (w)->feat_array[FEAT_TYPE_R]
#define word_get_S(w)     (w)->feat_array[FEAT_TYPE_S]
#define word_get_T(w)     (w)->feat_array[FEAT_TYPE_T]
#define word_get_U(w)     (w)->feat_array[FEAT_TYPE_U]
#define word_get_V(w)     (w)->feat_array[FEAT_TYPE_V]
#define word_get_W(w)     (w)->feat_array[FEAT_TYPE_W]
#define word_get_X(w)     (w)->feat_array[FEAT_TYPE_X]
#define word_get_Y(w)     (w)->feat_array[FEAT_TYPE_Y]
#define word_get_Z(w)     (w)->feat_array[FEAT_TYPE_Z]
#define word_get_signature(w)     (w)->signature

#define word_set_index(w, val) (w)->feat_array[FEAT_TYPE_INDEX] = (val)
#define word_set_form(w, val)  (w)->feat_array[FEAT_TYPE_FORM] = (val)
#define word_set_lemma(w, val) (w)->feat_array[FEAT_TYPE_LEMMA] = (val)
#define word_set_cpos(w, val)  (w)->feat_array[FEAT_TYPE_CPOS] = (val)
#define word_set_pos(w, val)   (w)->feat_array[FEAT_TYPE_POS] = (val)
#define word_set_feats(w, val) (w)->feat_array[FEAT_TYPE_FEATS] = (val)
#define word_set_gov(w, val)   (w)->feat_array[FEAT_TYPE_GOV] = (val)
#define word_set_label(w, val) (w)->feat_array[FEAT_TYPE_LABEL] = (val)
#define word_set_stag(w, val)  (w)->feat_array[FEAT_TYPE_STAG] = (val)
#define word_set_A(w, val)     (w)->feat_array[FEAT_TYPE_A] = (val)
#define word_set_B(w, val)     (w)->feat_array[FEAT_TYPE_B] = (val)
#define word_set_C(w, val)     (w)->feat_array[FEAT_TYPE_C] = (val)
#define word_set_D(w, val)     (w)->feat_array[FEAT_TYPE_D] = (val)
#define word_set_E(w, val)     (w)->feat_array[FEAT_TYPE_E] = (val)
#define word_set_F(w, val)     (w)->feat_array[FEAT_TYPE_F] = (val)
#define word_set_G(w, val)     (w)->feat_array[FEAT_TYPE_G] = (val)
#define word_set_H(w, val)     (w)->feat_array[FEAT_TYPE_H] = (val)
#define word_set_I(w, val)     (w)->feat_array[FEAT_TYPE_I] = (val)
#define word_set_J(w, val)     (w)->feat_array[FEAT_TYPE_J] = (val)
#define word_set_K(w, val)     (w)->feat_array[FEAT_TYPE_K] = (val)
#define word_set_L(w, val)     (w)->feat_array[FEAT_TYPE_L] = (val)
#define word_set_M(w, val)     (w)->feat_array[FEAT_TYPE_M] = (val)
#define word_set_N(w, val)     (w)->feat_array[FEAT_TYPE_N] = (val)
#define word_set_O(w, val)     (w)->feat_array[FEAT_TYPE_O] = (val)
#define word_set_P(w, val)     (w)->feat_array[FEAT_TYPE_P] = (val)
#define word_set_Q(w, val)     (w)->feat_array[FEAT_TYPE_Q] = (val)
#define word_set_R(w, val)     (w)->feat_array[FEAT_TYPE_R] = (val)
#define word_set_S(w, val)     (w)->feat_array[FEAT_TYPE_S] = (val)
#define word_set_T(w, val)     (w)->feat_array[FEAT_TYPE_T] = (val)
#define word_set_U(w, val)     (w)->feat_array[FEAT_TYPE_U] = (val)
#define word_set_V(w, val)     (w)->feat_array[FEAT_TYPE_V] = (val)
#define word_set_W(w, val)     (w)->feat_array[FEAT_TYPE_W] = (val)
#define word_set_X(w, val)     (w)->feat_array[FEAT_TYPE_X] = (val)

#define word_set_Y(w, val)     (w)->feat_array[FEAT_TYPE_Y] = (val)
#define word_set_Z(w, val)     (w)->feat_array[FEAT_TYPE_Z] = (val)
#define word_set_signature(w, val)     (w)->signature = (val)

typedef struct _word {
  int feat_array[FEAT_TYPE_NB]; /* array containing the codes corresponding to the different word features */
  char *input;                  /* the string corresponding to the actual line in the corpus file */
  int U1;                       /* does the form begin with an uppercase character */
  int signature;                /* pos tags that this form can have (represented as a boolean string) */
  int label;
  char *form;
} word;

word *word_new(char *input);
word *word_create_dummy(mcd *mcd_struct);

word *word_copy(word *w);
void word_free(word *w);
void word_print(FILE *f, word *w, mcd *mcd_struct, dico *dico_labels);

word *word_read(FILE *f, mcd *mcd_struct);

word *word_parse_buffer(char *buffer, mcd *mcd_struct);


#endif
